/*
	This file is part of CrabEmu.

	Copyright (C) 2005 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "sms.h"
#include "smsvdp.h"
#include "smsmem.h"
#include "smsz80.h"

unsigned short sms_pad = 0xFFFF;
int sms_running;

int sms_init()	{
	sms_mem_init();
	sms_vdp_init();
	sms_z80_init();
	sms_running = 0;

	return 0;
}

int sms_shutdown()	{
	if(sms_running == 1)
		sms_stop();

	sms_mem_shutdown();
	sms_vdp_shutdown();
	sms_z80_shutdown();

	return 0;
}

void sms_frame()	{
	int line;

	for(line = 0; line < 262; ++line)	{
		sms_z80_run(227);
		sms_vdp_execute(line);
	}
}

void sms_stop()	{
	sms_running = -1;

	while(sms_running == -1)	;
}

void sms_button_pressed(int button)	{
	sms_pad &= ~button;
}

void sms_button_released(int button)	{
	sms_pad |= button;
}
