/*
	This file is part of CrabEmu.

	Copyright (C) 2005 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#import "EmuController.h"
#include "sms.h"
#include "smsmem.h"

/* From main.m */
extern void emu_loop();

extern int framewait;

@implementation EmuController

- (IBAction)loadMasterRom:(id)sender
{
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	[openPanel setTitle: @"Choose a Master System ROM"];
	[openPanel setCanChooseDirectories: NO];
	
	if([openPanel runModal] == NSOKButton)	{
		NSString *filePath = [openPanel filename];

		sms_init();
		sms_mem_load_rom([filePath UTF8String]);
	}
	started = 0;
}

- (IBAction)startMasterSys:(id)sender
{
	if(!started)	{
		[masterStart setState:NSOnState];
		[NSThread detachNewThreadSelector:@selector(masterEmuThread:) toTarget:self withObject:nil];
		started = 1;
	}
}

- (void)masterEmuThread:(id)junk
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	emu_loop();

	sms_shutdown();
	[pool release];
}

@end
