/*
	This file is part of CrabEmu.

	Copyright (C) 2005 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef SMS_H
#define SMS_H

extern int sms_init(void);
extern int sms_reset(void);
extern int sms_shutdown(void);

extern void sms_frame(void);

extern void gui_set_viewport(int w, int h);
extern void sms_button_pressed(int button);
extern void sms_button_released(int button);

/* Button defines */
#define SMS_PAD1_UP     0x0001
#define SMS_PAD1_DOWN   0x0002
#define SMS_PAD1_LEFT   0x0004
#define SMS_PAD1_RIGHT  0x0008
#define SMS_PAD1_A      0x0010
#define SMS_PAD1_B      0x0020
#define SMS_PAD2_UP     0x0040
#define SMS_PAD2_DOWN   0x0080
#define SMS_PAD2_LEFT   0x0100
#define SMS_PAD2_RIGHT  0x0200
#define SMS_PAD2_A      0x0400
#define SMS_PAD2_B      0x0800
#define SMS_RESET       0x1000
#define GG_START        0xFFFF

/* Console types */
#define CONSOLE_SMS 1
#define CONSOLE_GG  2

/* Region types */
#define SMS_REGION_DOMESTIC 0x01
#define SMS_REGION_EXPORT   0x02

/* Video Standards */
#define SMS_VIDEO_NTSC 0x10
#define SMS_VIDEO_PAL  0x20


#endif /* !SMS_H */
