/*
	This file is part of CrabEmu.

	Copyright (C) 2005, 2006 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef EMUCONTROLLER_H
#define EMUCONTROLLER_H

#import <Cocoa/Cocoa.h>

@class NSOpenGLContext;

@interface EmuController : NSObject
{
    IBOutlet NSMenuItem *noise;
    IBOutlet NSMenuItem *pause;
    IBOutlet NSMenuItem *PSG;
    IBOutlet NSMenuItem *tone0;
    IBOutlet NSMenuItem *tone1;
    IBOutlet NSMenuItem *tone2;
    IBOutlet NSMenuItem *debugger;
    IBOutlet NSMenuItem *normalSize;
    IBOutlet NSMenuItem *doubleSize;
    IBOutlet NSPanel *virtKeyboard;
    IBOutlet NSPanel *prefWindow;
    IBOutlet NSWindow *debuggerWindow;

    NSUserDefaults *prefs;
    NSString *buttonmap;
    NSString *openRom;
}

- (void)awakeFromNib;
- (void)dealloc;

- (IBAction)enableNoise:(id)sender;
- (IBAction)enablePSG:(id)sender;
- (IBAction)enableTone0:(id)sender;
- (IBAction)enableTone1:(id)sender;
- (IBAction)enableTone2:(id)sender;
- (IBAction)loadMasterRom:(id)sender;
- (IBAction)prefGGStart:(id)sender;
- (IBAction)prefSms1B1:(id)sender;
- (IBAction)prefSms1B2:(id)sender;
- (IBAction)prefSms1Down:(id)sender;
- (IBAction)prefSms1Left:(id)sender;
- (IBAction)prefSms1Reset:(id)sender;
- (IBAction)prefSms1Right:(id)sender;
- (IBAction)prefSms1Up:(id)sender;
- (IBAction)prefSms2B1:(id)sender;
- (IBAction)prefSms2B2:(id)sender;
- (IBAction)prefSms2Down:(id)sender;
- (IBAction)prefSms2Left:(id)sender;
- (IBAction)prefSms2Reset:(id)sender;
- (IBAction)prefSms2Right:(id)sender;
- (IBAction)prefSms2Up:(id)sender;
- (IBAction)enableDebugger:(id)sender;
- (IBAction)rendererNormal:(id)sender;
- (IBAction)rendererDouble:(id)sender;
- (IBAction)saveSRAM:(id)sender;
- (IBAction)saveState1:(id)sender;
- (IBAction)saveState2:(id)sender;
- (IBAction)saveState3:(id)sender;
- (IBAction)saveState4:(id)sender;
- (IBAction)saveState5:(id)sender;
- (IBAction)saveState6:(id)sender;
- (IBAction)loadState1:(id)sender;
- (IBAction)loadState2:(id)sender;
- (IBAction)loadState3:(id)sender;
- (IBAction)loadState4:(id)sender;
- (IBAction)loadState5:(id)sender;
- (IBAction)loadState6:(id)sender;
- (IBAction)resetEmulation:(id)sender;

- (unichar)runVirtKeyboard;
- (void)endVirtKeyboard:(unichar)character;

- (void)masterEmuThread:(id)junk;
- (void)pauseEmulation:(id)sender;

- (void)updateButtonMapFromString:(NSString *)str;
- (NSString *)buttonMap;

@end

#endif
