/*
    This file is part of CrabEmu.

    Copyright (C) 2005, 2006, 2007 Lawrence Sebald

    CrabEmu is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 
    as published by the Free Software Foundation.

    CrabEmu is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CrabEmu; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include "smsz80.h"
#include "../../cpu/mamez80/z80.h"

CrabZ80_t *cpuz80 = NULL;

void program_write_byte_8(UINT32 addr, UINT8 val)   {
    sms_mem_write((uint16)addr, val);
}

UINT8 program_read_byte_8(UINT32 addr)  {
    return sms_mem_read((uint16)addr);
}

void io_write_byte_8(UINT32 port, UINT8 val)    {
    sms_port_write((uint16)port & 0xFF, val);
}

UINT8 io_read_byte_8(UINT32 port)   {
    return sms_port_read((uint16)port & 0xFF);
}


int sms_z80_init(void)  {
    z80_init();
    z80_reset();
    
    return 0;
}

int sms_z80_shutdown(void)  {
    z80_exit();

    return 0;
}

void sms_z80_reset(void)    {
    z80_reset();
}

void sms_z80_irq(void)  {
    z80_set_irq_line(INPUT_LINE_NMI + 1, 1);
}

void sms_z80_nmi(void)  {
    z80_set_irq_line(INPUT_LINE_NMI, 1);
}

uint32 sms_z80_run(uint32 cycles)   {
    return z80_execute(cycles);
}

void sms_z80_write_context(FILE *fp __attribute__((unused)))    {
}

void sms_z80_read_context(FILE *fp __attribute__((unused))) {
}
